/* 
   file:  close.c

   function for calculating who is closest to ball
   */

#include "libsclient.h"
#include <math.h>

#define  PI (3.1415927)

Bool closer_than_me (double pldir, double pldist, double bldir, double bldist) {
    double ang, rang,  plbldist, cosang;
    ang = abs(pldir - bldir);
    rang = ang*PI/180.0; 
    cosang = cos(rang) ;
    plbldist = sqrt( (pldist * pldist) + (bldist * bldist) - ( 2 * pldist * bldist * cosang ) );

    return (bldist > plbldist);
}
