/*
 *	Header:
 *	File: location.c
 *	Author: Jafar + Yaser
 *	Date: 07/03/1997
 *	EndHeader:
 */

#include <stdio.h>
#include <math.h>

#define TRUE 1
#define FALSE 0
#define CLOSE 3

/* #define PI 3.1415 */


/* the main function to test location function */
/* int location(current_x,  current_y,  dest_x, dest_y, angle , turn_angle,  distance); */
/*
void main()
{
  double current_x,current_y,dest_x,dest_y,theta,d,phi;
  int power ;
  
  for(; ; ){
    printf("\ncurrent_x =");
    scanf("%lf", &current_x);
    
    printf("\ncurrent_y =");
    scanf("%lf", &current_y);
    
    printf("\ndest_x =");
    scanf("%lf", &dest_x);

    printf("\ndest_y =");
    scanf("%lf", &dest_y);


//    printf("\n Atan = %lf atan(1) = %lf atan(-1) %lf",(current_x==dest_x)? 90: atan((dest_y-current_y)/(dest_x-current_x)),atan((double)0.0),atan((double)1.0));

    printf("\ntheta =");
    scanf("%lf", &theta);
    if (location(current_x,current_y,dest_x,dest_y,theta,&phi,&power) == TRUE){
      printf("\n Turn Angle = %lf Distance = %d \n",phi,power);
    }
    else printf("\n Failed to compute it ...\n");
  }
}

*/


int location(double current_x, double current_y, double dest_x,
	     double dest_y, double angle, 
	     double *turn_angle, int *power)
     /* This function computes the angle you need to turn and the power you need to move 
	from the point (current_x,current_y) to the point (dest_x,dest_y) and your heading 
	direction of angle */ 
{
  double x_diff,y_diff, temp;

  x_diff = dest_x - current_x ;
  y_diff = dest_y - current_y ;
  
  /* fprintf(stderr,"xdiff ydiff: %2.1lf %2.1lf\n", x_diff, y_diff); */

  temp = (int) sqrt(x_diff*x_diff + y_diff*y_diff) ;

  if (CLOSE < temp)
    {
      if (temp > 20 ) 
	*power = 100 ;
      else
	*power = 40;
      
      *(turn_angle) = ((atan2 (y_diff ,x_diff) * (180.0 / 3.1415)) -  angle) ; 

      if (abs(*turn_angle) > 180.0)
	{   /* angles > 180 is converted to smaller opposite angles */
	  *turn_angle = (360.0 - abs(*turn_angle)) * ((*turn_angle > 0 )? -1 : 1) ;
	}
    }
  else
    {
      *power = 0;
      *turn_angle = 0.0;
    }

  /* fprintf(stderr,"location says: %2.1lf %d\n",*turn_angle, *power); */
  return(TRUE);
}
























