
/***
  file:       soar2c.h
  Author:     Gal K.
  Date:       6-25-97
***/

/* Macro definitions for accessing, creating WMEs, and updating them,
   as well as other soar<-->C interface functions */


#define  CREATE_WME(root, attrib, attrib_init, value, value_init) \
              add_input_wme((root), ((attrib)=(attrib_init)), ((value)=(value_init)))

#define  CREATE_WME_VALUE(root, attrib, value, value_init) \
              add_input_wme((root), (attrib), ((value)=(value_init)))

#define  CREATE_WME_ATTRIB_CONST(root, attrib, attrib_init, value) \
              add_input_wme((root), ((attrib)=(attrib_init)), (value))

#define  CREATE_WME_CONST(root, attrib, value)               \
              add_input_wme((root), (attrib), (value))
     
     
#define  UPDATE_WME(wme, root, attrib_var, value_var, new_value) \
              {                                                  \
		remove_input_wme(wme);                           \
		release_io_symbol(value_var);                    \
                wme = add_input_wme(root, attrib_var, ((value_var) = (new_value))); \
	      }

#define  UPDATE_WME_CONST(wme, root, attrib_var, new_value)        \
              {                                                    \
		remove_input_wme(wme);                             \
                wme = add_input_wme(root, attrib_var, new_value);  \
	      }

