/* File   : geometry.c
   Info   : useful functions
   Author : Ali Erdem (some by Gal Kaminka)
   Date   : June 27, 1997 and on
*/

#define  __GEO_EXTERN
#include "geometry.h"

int estimate_object_pos(ObjInfo *obj_info)
{
    if (State[NOW].Players[OWN][MyNumber-1].position.pos.x && State[NOW].Players[OWN][MyNumber-1].position.pos.y) {
       obj_info->position.pos.x = State[NOW].Players[OWN][MyNumber-1].position.pos.x + obj_info->SeenInfo.dist * cos(Deg2Rad(obj_info->SeenInfo.dir));
       obj_info->position.pos.y = State[NOW].Players[OWN][MyNumber-1].position.pos.y + obj_info->SeenInfo.dist * sin(Deg2Rad(obj_info->SeenInfo.dir));
       return 1;
    }

    return 0;
}

double NormalizeAngle(double angle)
{
   if (angle > 180.0) {
      return angle-((int)(angle/360.0)+1)*360;
   } else if (angle < -180.0) {
      return angle+((int)(-angle/360.0)+1)*360;
   } else {
     return angle;
   }
}

